TEMPLATE = app
QT += gui widgets
TARGET = Kalkulon
DEPENDPATH += .
INCLUDEPATH += .

CONFIG += c++11
QMAKE_CXXFLAGS += -std=c++11

#CONFIG +=release
CONFIG += debug_and_release

CONFIG(debug, debug|release) {
    OBJECTS_DIR = debug
    DESTDIR = debug
    DEFINES += _DEBUG
 } else {
    OBJECTS_DIR = release
    DESTDIR = ./
 }


# Input GUI
FORMS +=    gui/kalkulon.ui \
            gui/optionsDlg.ui

RESOURCES = gui/kalkulon.qrc

HEADERS +=  gui/KalkulonDlg.h \
            gui/SyntaxHighlighter.h \
            gui/OptionsDlg.h \

SOURCES +=  gui/kalkulon.cpp \
            gui/KalkulonDlg.cpp \
            gui/SyntaxHighlighter.cpp \
            gui/OptionsDlg.cpp

# for Win32 application icon
win32 {
    RC_FILE = gui/res/kalkulon_win32.rc
}

# Input Kalkulon core
HEADERS +=  core/kalkuloncore.h \
            core/ArithParser.h \
            core/commands.h \
            core/DataObject.h \
            core/DataStack.h \
            core/ErrBase.h \
            core/fnlist.h \
            core/fnlist_impl.h \
            core/fnlist_internal.h \
            core/FuncObject.h \
            core/itoa.h \
            core/math1.h \
            core/RPNStackEval.h \
            core/stdafx.h \
            core/Token.h \
            core/version1.h \
            core/serialize.h

SOURCES +=  core/ArithParser.cpp \
            core/commands.cpp \
            core/DataObject.cpp \
            core/DataStack.cpp \
            core/ErrBase.cpp \
            core/fnlist.cpp \
            core/FuncObject.cpp \
            core/itoa.cpp \
            core/math1.cpp \
            core/RPNStackEval.cpp \
            core/RPNStackEval_fn.cpp \
            core/StdAfx.cpp \
            core/Token.cpp
